﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Representation
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            var node5 = new Employee() { Name = "Node 5" };
            var node4 = new Employee() { Name = "Node 4", EmployeeType = "Manager", Subordinates = new ObservableCollection<Employee>() { node5   } };
            var node3 = new Employee() { Name = "Node 3", EmployeeType = "Trainee", Subordinates = new ObservableCollection<Employee>() { node4,  } };
            var node2 = new Employee() { Name = "Node 2", EmployeeType = "Trainee", Subordinates = new ObservableCollection<Employee>() { node3 } };

            var snode5 = new Employee() { Name = "sNode 5", EmployeeType = "Manager" };
            var snode4 = new Employee() { Name = "sNode 4", EmployeeType = "Manager", Subordinates = new ObservableCollection<Employee>() { snode5 } };
            var snode3 = new Employee() { Name = "sNode 3", EmployeeType = "Trainee", Subordinates = new ObservableCollection<Employee>() { snode4 } };
            var snode2 = new Employee() { Name = "sNode 2", EmployeeType = "Trainee", Subordinates = new ObservableCollection<Employee>() { snode3 } };

            var snode1 = new Employee() { Name = "sNode 1", EmployeeType = "Trainee", Subordinates = new ObservableCollection<Employee>() { snode2 } };
            var node1 = new Employee() { Name = "Node 1", EmployeeType = "Manager", Subordinates = new ObservableCollection<Employee>() { node2 } };
            var tnode1 = new Employee() { Name = "tNode", EmployeeType = "Manager" };
           

            myDiagram.ItemsSource = new[] { tnode1,snode1, node1 };                                                                                                        
        }

    }

    public class MyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            Employee e = value as Employee;
            return e.EmployeeType;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class Employee : INotifyPropertyChanged
    {

        private string _name;
        private string _type;

        public string EmployeeType
        {
            get
            {
                return _type;
            }
            set
            {
                _type = value;
                OnPropertyChanged("EmployeeType");
            }
        }

        public string Name 
        {
            get
            {
                return _name;
            }
            set 
            { 
                _name = value;
                OnPropertyChanged("Name"); 
            } 
        }

        private ObservableCollection<Employee> subordinates;

        public ObservableCollection<Employee> Subordinates 
        { 
            get { return subordinates; } 
            set { subordinates = value; }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName) 
        { if (PropertyChanged != null) 
            PropertyChanged(this, new PropertyChangedEventArgs(propertyName)); 
        }

    } 

}
